<template>
  <div v-loading="loading">
    <CDataTable
      hover
      :items="data"
      :fields="FIELDS"
      class="thing-table"
    >
      <template #control="{item}">
        <td>
          <CSwitch
            :id="item.id"
            :checked="item.status === 1"
            color="primary"
            variant="3d"
            shape="pill"
            label-on="On"
            label-off="Off"
            @update:checked="onChangeStatusGroup"
          />
        </td>
      </template>

      <template #colors="{item}">
        <td>
          <div :style="getColors(item.color_r, item.color_g, item.color_b)" class="color-tags" />
        </td>
      </template>

      <template #group="{item}">
        <td>
          {{ item.group ? item.group.name : '' }}
        </td>
      </template>

      <template #status="{item}">
        <td>
          <span :class="`badge badge-${item.status === 1 ? 'success' : 'danger'}`">
            {{ item.status === 1 ? 'ON' : 'OFF' }}
          </span>
        </td>
      </template>

      <template #action="{item}">
        <td class="white-space-nowrap">
          <CButton size="sm" color="primary" @click="onShowDetail(item.id)">
            <font-awesome-icon :icon="['fas', 'pencil-alt']" />
          </CButton>
          &nbsp;
          <CButton size="sm" color="danger" @click="onDelete(item.id)">
            <font-awesome-icon :icon="['fas', 'trash-alt']" />
          </CButton>
        </td>
      </template>
    </CDataTable>
  </div>
</template>

<style lang="scss" scoped>
  .thing-table {
    /deep/ {
      table {
        border-bottom: 1px solid #d8dbe0;
        margin-bottom: 0;
        thead {
          tr {
            th {
              &.id {
                width: 60px;
              }
              &.name {
                width: 100px;
              }
              &.group {
                width: 100px;
              }
              &.ip_address {
                width: 250px;
              }
              &.status {
                width: 150px;
              }
              &.colors {
                width: 100px;
              }
              &.control {
                width: 100px;
              }
              &.action {
                width: 60px;
              }
            }
          }
        }
      }
    }
  }
  .color-tags {
    width: 30px;
    height: 30px;
    border-radius: 50%;
  }
</style>

<script>
const FIELDS = [
  { key: 'id', label: 'No.', _classes: 'id' },
  { key: 'name', label: 'Thing Name', _classes: 'name' },
  { key: 'group', label: 'Group', _classes: 'group' },
  { key: 'ip_address', _classes: 'ip_address' },
  { key: 'status', _classes: 'status' },
  { key: 'colors', label: 'Colors', _classes: 'colors' },
  { key: 'control', sorter: false, _classes: 'control' },
  { key: 'action', label: 'Action', sorter: false, _classes: 'action' }
]

const EVENT_MODIFY = 'modify'
const EVENT_DELETE = 'delete'
const EVENT_SHOW_DETAIL = 'show-detail'

export default {
  props: {
    /**
     * User list
     */
    data: {
      type: Array,
      default: () => []
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      editThing: false,
      thingItem: {},
      details: [],
      status: 0
    }
  },

  computed: {
    /**
     * Get FIELDS of header table
     *
     * @return {array} FIELDS of header table
     */
    FIELDS () {
      return FIELDS
    }
  },

  methods: {
    /**
     * Event show thing detail modal
     *
     * @param {number} id - thing id
     */
    onShowDetail (id) {
      this.$emit(EVENT_SHOW_DETAIL, id)
    },

    /**
     * Return style colors of rgb
     *
     * @param {Number} RColor - Value rgb color
     * @param {Number} GColor - Value rgb color
     * @param {Number} BColor - Value rgb color
     */
    getColors (RColor, GColor, BColor) {
      return { 'background-color': `rgb(${RColor}, ${GColor}, ${BColor})` }
    },

    /**
     * Delete thing item
     *
     * @param {Number} id - Thing id
     */
    onDelete (id) {
      this.$emit(EVENT_DELETE, id)
    },

    /**
     * Event when change status of group
     *
     * @return {Boolean} val - True if checkbox is checked, else false
     * @return {Object} event - Event object of checkbox
     */
    async onChangeStatusGroup (val, event) {
      if (!event.target.id) {
        return
      }

      try {
        let res = null

        if (val === true) {
          res = await this.$dam.updateThing({
            id: +event.target.id,
            status: 1
          })
        } else {
          res = await this.$dam.updateThing({
            id: +event.target.id,
            status: 0
          })
        }

        if (res && res.data && res.data.id) {
          this.$toast.success(
            this.$text.info('UPDATED', { name: 'group' })
          )
          this.$emit(EVENT_MODIFY)
        }
      } catch (err) {
        console.error(err)

        this.$toast.error(
          this.$text.error('FAILED_TO_UPDATE', { name: 'group' })
        )
      }
    }
  }
}
</script>
